/*
 * Copyright (c) 2017 Fraunhofer FOKUS.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the
 * GNU AGPL v3 which accompanies
 * this distribution, and is available at
 * http://www.gnu.org/licenses/agpl.txt
 *
 * Contributors:
 * Simon Dutkowski Fraunhofer FOKUS
 *
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 */
package eu.DECIDEh2020.appManager.models;

import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.JsonNode;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class Container {

    private String name;
    private String imageName;
    private String imageTag;

    private String dockerPrivateRegistryIp;
    private Integer dockerPrivateRegistryPort;

    private String hostname;
    private String restart;

    private List<String> command = new ArrayList<>();
    private List<String> entrypoint = new ArrayList<>();

    private String dockerHostNodeName;

    private List<String> networks = new ArrayList<>();

    private List<VolumeMapping> volumeMapping = new ArrayList<>();

    private List<String> environment = new ArrayList<>();

    private String consulKvProviderNodeName;
    private Integer addConsulService;

    private Integer consulServicePort;

    private Integer addConsulTraefikRules;

    private List<PortMapping> portMapping = new ArrayList<>();

    private List<Endpoint> endpoints = new ArrayList<>();

    private Map<String, JsonNode> additionalProperties = new HashMap<>();

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getImageName() {
        return imageName;
    }

    public void setImageName(String imageName) {
        this.imageName = imageName;
    }

    public String getImageTag() {
        return imageTag;
    }

    public void setImageTag(String imageTag) {
        this.imageTag = imageTag;
    }

    public String getDockerPrivateRegistryIp() {
        return dockerPrivateRegistryIp;
    }

    public void setDockerPrivateRegistryIp(String dockerPrivateRegistryIp) {
        this.dockerPrivateRegistryIp = dockerPrivateRegistryIp;
    }

    public Integer getDockerPrivateRegistryPort() {
        return dockerPrivateRegistryPort;
    }

    public void setDockerPrivateRegistryPort(Integer dockerPrivateRegistryPort) {
        this.dockerPrivateRegistryPort = dockerPrivateRegistryPort;
    }

    public String getHostname() {
        return hostname;
    }

    public void setHostname(String hostname) {
        this.hostname = hostname;
    }

    public String getRestart() {
        return restart;
    }

    public void setRestart(String restart) {
        this.restart = restart;
    }

    public List<String> getCommand() {
        return command;
    }

    public void setCommand(List<String> command) {
        this.command = command;
    }

    public List<String> getEntrypoint() {
        return entrypoint;
    }

    public void setEntrypoint(List<String> entrypoint) {
        this.entrypoint = entrypoint;
    }

    public String getDockerHostNodeName() {
        return dockerHostNodeName;
    }

    public void setDockerHostNodeName(String dockerHostNodeName) {
        this.dockerHostNodeName = dockerHostNodeName;
    }

    public List<String> getNetworks() {
        return networks;
    }

    public void setNetworks(List<String> networks) {
        this.networks = networks;
    }

    public List<VolumeMapping> getVolumeMapping() {
        return volumeMapping;
    }

    public void setVolumeMapping(List<VolumeMapping> volumeMapping) {
        this.volumeMapping = volumeMapping;
    }

    public List<String> getEnvironment() {
        return environment;
    }

    public void setEnvironment(List<String> environment) {
        this.environment = environment;
    }

    public String getConsulKvProviderNodeName() {
        return consulKvProviderNodeName;
    }

    public void setConsulKvProviderNodeName(String consulKvProviderNodeName) {
        this.consulKvProviderNodeName = consulKvProviderNodeName;
    }

    public Integer getAddConsulService() {
        return addConsulService;
    }

    public void setAddConsulService(Integer addConsulService) {
        this.addConsulService = addConsulService;
    }

    public List<PortMapping> getPortMapping() {
        return portMapping;
    }

    public void setPortMapping(List<PortMapping> portMapping) {
        this.portMapping = portMapping;
    }

    public List<Endpoint> getEndpoints() {
        return endpoints;
    }

    public void setEndpoints(List<Endpoint> endpoints) {
        this.endpoints = endpoints;
    }

    public Integer getConsulServicePort() {
        return consulServicePort;
    }

    public void setConsulServicePort(Integer consulServicePort) {
        this.consulServicePort = consulServicePort;
    }

    public void setAddConsulTraefikRules(Integer addConsulTraefikRules) {
        this.addConsulTraefikRules = addConsulTraefikRules;
    }

    public Integer getAddConsulTraefikRules() {
        return addConsulTraefikRules;
    }

    @JsonAnyGetter
    public Map<String, JsonNode> getAdditionalProperties() {
        return additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperties(String property, JsonNode value) {
        additionalProperties.put(property, value);
    }

}
