/*
 * Copyright (c) 2017 Fraunhofer FOKUS.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the
 * GNU AGPL v3 which accompanies
 * this distribution, and is available at
 * http://www.gnu.org/licenses/agpl.txt
 *
 * Contributors:
 * Simon Dutkowski Fraunhofer FOKUS
 *
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 */
package eu.DECIDEh2020.appManager.models;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.node.ObjectNode;

import java.util.ArrayList;
import java.util.List;

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class HistoryEntry {

    private String date;

    private SchemaElement schema = new SchemaElement();

    private List<ObjectNode> slaBreaches = new ArrayList<>();

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public SchemaElement getSchema() {
        return schema;
    }

    public void setSchema(SchemaElement schema) {
        this.schema = schema;
    }

    public List<ObjectNode> getSlaBreaches() {
        return slaBreaches;
    }

    public void setSlaBreaches(List<ObjectNode> slaBreaches) {
        this.slaBreaches = slaBreaches;
    }

}
