/*
 * Copyright (c) 2017 Fraunhofer FOKUS.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the
 * GNU AGPL v3 which accompanies
 * this distribution, and is available at
 * http://www.gnu.org/licenses/agpl.txt
 *
 * Contributors:
 * Simon Dutkowski Fraunhofer FOKUS
 *
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 */
package eu.DECIDEh2020.appManager.models;

import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(Include.NON_EMPTY)
public class Microservice {

	private String id;
	private String name;
	private String classification;
	private Boolean stateful = false;
	private String programmingLanguage;
	private String sourceRepository;
	private List<String> tags = new ArrayList<>();
	private Boolean publicIP = false;
	private List<String> endpoints = new ArrayList<>();
	private String containerId;
	private String containerRef;
	private Integer deploymentOrder;
	private List<String> dependencies = new ArrayList<>();
	private List<String> safeMethods = new ArrayList<>();
	private List<DetachableResource> detachableResources = new ArrayList<>();
	private InfrastructureRequirements infrastructureRequirements;

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getClassification() {
		return classification;
	}

	public void setClassification(String classification) {
		this.classification = classification;
	}

	public Boolean isStateful() {
		return stateful;
	}

	public void setStateful(Boolean stateful) {
		this.stateful = stateful;
	}

	public String getProgrammingLanguage() {
		return programmingLanguage;
	}

	public void setProgrammingLanguage(String programmingLanguage) {
		this.programmingLanguage = programmingLanguage;
	}

	public String getSourceRepository() {
		return sourceRepository;
	}

	public void setSourceRepository(String sourceRepository) {
		this.sourceRepository = sourceRepository;
	}

	public List<String> getTags() {
		return tags;
	}

	public void setTags(List<String> tags) {
		this.tags = tags;
	}

	public void setNfrs(List<String> tags) {
		this.tags = tags;
	}

	public Boolean isPublicIP() {
		return publicIP;
	}

	public void setPublicIP(Boolean publicIP) {
		this.publicIP = publicIP;
	}

	public List<String> getEndpoints() {
		return endpoints;
	}

	public void setEndpoints(List<String> endpoints) {
		this.endpoints = endpoints;
	}

	public String getContainerId() {
		return containerId;
	}

	public void setContainerId(String containerId) {
		this.containerId = containerId;
	}

	public String getContainerRef() {
		return containerRef;
	}

	public void setContainerRef(String containerRef) {
		this.containerRef = containerRef;
	}

	public Integer getDeploymentOrder() {
		return deploymentOrder;
	}

	public void setDeploymentOrder(Integer deploymentOrder) {
		this.deploymentOrder = deploymentOrder;
	}

	public List<String> getDependencies() {
		return dependencies;
	}

	public void setDependencies(List<String> dependencies) {
		this.dependencies = dependencies;
	}

	public List<String> getSafeMethods() {
		return safeMethods;
	}

	public void setSafeMethods(List<String> safeMethods) {
		this.safeMethods = safeMethods;
	}

	public List<DetachableResource> getDetachableResources() {
		return detachableResources;
	}

	public void setDetachableResources(List<DetachableResource> detachableResources) {
		this.detachableResources = detachableResources;
	}

	public InfrastructureRequirements getInfrastructureRequirements() {
		return infrastructureRequirements;
	}

	public void setInfrastructureRequirements(InfrastructureRequirements infrastructureRequirements) {
		this.infrastructureRequirements = infrastructureRequirements;
	}

}
