/*
 * Copyright (c) 2017 Fraunhofer FOKUS.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the
 * GNU AGPL v3 which accompanies
 * this distribution, and is available at
 * http://www.gnu.org/licenses/agpl.txt
 *
 * Contributors:
 * Simon Dutkowski Fraunhofer FOKUS
 *
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 */
package eu.DECIDEh2020.appManager.models;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;

import java.util.ArrayList;
import java.util.List;

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(Include.NON_EMPTY)
public class ServiceObjective {

	private String comment;
	private String termName;

	private String type;

	private String value;
	private String unit;
	private String conditionStatement;
	private List<ViolationTriggerRule> violationTriggerRules = new ArrayList<>();
	private Remedy remedy;
	private List<Metric> metrics = new ArrayList<>();

	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}

	public String getTermName() {
		return termName;
	}

	public void setTermName(String termName) {
		this.termName = termName;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public String getUnit() {
		return unit;
	}

	public void setUnit(String unit) {
		this.unit = unit;
	}

	public String getConditionStatement() {
		return conditionStatement;
	}

	public void setConditionStatement(String conditionStatement) {
		this.conditionStatement = conditionStatement;
	}

	public List<ViolationTriggerRule> getViolationTriggerRules() {
		return violationTriggerRules;
	}

	public void setViolationTriggerRules(List<ViolationTriggerRule> violationTriggerRules) {
		this.violationTriggerRules = violationTriggerRules;
	}

	public Remedy getRemedy() {
		return remedy;
	}

	public void setRemedy(Remedy remedy) {
		this.remedy = remedy;
	}

	public List<Metric> getMetrics() {
		return metrics;
	}

	public void setMetrics(List<Metric> metrics) {
		this.metrics = metrics;
	}

}
