/*
 * Copyright (c) 2017 Fraunhofer FOKUS.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the
 * GNU AGPL v3 which accompanies
 * this distribution, and is available at
 * http://www.gnu.org/licenses/agpl.txt
 *
 * Contributors:
 * Simon Dutkowski Fraunhofer FOKUS
 *
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 */
package eu.DECIDEh2020.appManager;

import com.fasterxml.jackson.databind.ObjectMapper;
import eu.DECIDEh2020.appManager.exceptions.DECIDEValidationException;
import eu.DECIDEh2020.appManager.models.HistoryEntry;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.testng.annotations.Test;

import java.io.IOException;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import java.util.Arrays;
import java.util.List;

public class HistoryFactoryTest {

    private Logger log = LoggerFactory.getLogger(getClass());

    @Test
    public void validate() {
        Path path = FileSystems.getDefault().getPath("src/test/resources/OPTIMUSHistory.json");
        ObjectMapper mapper = new ObjectMapper();
        try {
            List<HistoryEntry> history = Arrays.asList(mapper.readValue(path.toFile(), HistoryEntry[].class));
            HistoryFactory.validateHistory(history);
            assert true;
        } catch (DECIDEValidationException | IOException e) {
            log.error("reading an validating json", e);
            assert false;
        }
    }

}
